# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc
import warnings

from frequenz.api.reporting.v1 import reporting_pb2 as frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2

GRPC_GENERATED_VERSION = '1.70.0'
GRPC_VERSION = grpc.__version__
_version_not_supported = False

try:
    from grpc._utilities import first_version_is_lower
    _version_not_supported = first_version_is_lower(GRPC_VERSION, GRPC_GENERATED_VERSION)
except ImportError:
    _version_not_supported = True

if _version_not_supported:
    raise RuntimeError(
        f'The grpc package installed is at version {GRPC_VERSION},'
        + f' but the generated code in frequenz/api/reporting/v1/reporting_pb2_grpc.py depends on'
        + f' grpcio>={GRPC_GENERATED_VERSION}.'
        + f' Please upgrade your grpc module to grpcio>={GRPC_GENERATED_VERSION}'
        + f' or downgrade your generated code using grpcio-tools<={GRPC_VERSION}.'
    )


class ReportingStub(object):
    """The Reporting service provides services for real-time and historical metrics monitoring
    of various microgrid components like Batteries, EV Chargers, and Inverters.

    Utilize these APIs for tasks ranging from real-time metric streaming to complex,
    formula-driven historical data aggregation. For detailed information on component
    categories and the metrics they provide, please consult the referenced component categories
    imported above.

    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.ReceiveMicrogridComponentsDataStream = channel.unary_stream(
                '/frequenz.api.reporting.v1.Reporting/ReceiveMicrogridComponentsDataStream',
                request_serializer=frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveMicrogridComponentsDataStreamRequest.SerializeToString,
                response_deserializer=frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveMicrogridComponentsDataStreamResponse.FromString,
                _registered_method=True)
        self.ReceiveAggregatedMicrogridComponentsDataStream = channel.unary_stream(
                '/frequenz.api.reporting.v1.Reporting/ReceiveAggregatedMicrogridComponentsDataStream',
                request_serializer=frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveAggregatedMicrogridComponentsDataStreamRequest.SerializeToString,
                response_deserializer=frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveAggregatedMicrogridComponentsDataStreamResponse.FromString,
                _registered_method=True)
        self.ReceiveMicrogridSensorsDataStream = channel.unary_stream(
                '/frequenz.api.reporting.v1.Reporting/ReceiveMicrogridSensorsDataStream',
                request_serializer=frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveMicrogridSensorsDataStreamRequest.SerializeToString,
                response_deserializer=frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveMicrogridSensorsDataStreamResponse.FromString,
                _registered_method=True)
        self.ReceiveAggregatedMicrogridSensorsDataStream = channel.unary_stream(
                '/frequenz.api.reporting.v1.Reporting/ReceiveAggregatedMicrogridSensorsDataStream',
                request_serializer=frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveAggregatedMicrogridSensorsDataStreamRequest.SerializeToString,
                response_deserializer=frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveAggregatedMicrogridSensorsDataStreamResponse.FromString,
                _registered_method=True)


class ReportingServicer(object):
    """The Reporting service provides services for real-time and historical metrics monitoring
    of various microgrid components like Batteries, EV Chargers, and Inverters.

    Utilize these APIs for tasks ranging from real-time metric streaming to complex,
    formula-driven historical data aggregation. For detailed information on component
    categories and the metrics they provide, please consult the referenced component categories
    imported above.

    """

    def ReceiveMicrogridComponentsDataStream(self, request, context):
        """Streams metrics for a list of microgrid components.

        !!! note
        This RPC endpoint streams metrics data for components of one or more microgrids.
        Clients need to provide at least one microgrid ID and one component ID
        to get a result.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def ReceiveAggregatedMicrogridComponentsDataStream(self, request, context):
        """Streams aggregated metrics based on user-defined formulas for a list of microgrid
        components.

        !!! note
        This RPC endpoint retrieves aggregated historical metrics data based on user-defined
        formulas for microgrid components. At least one formula for one microgrid must be provided
        for a valid result.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def ReceiveMicrogridSensorsDataStream(self, request, context):
        """Streams metrics for a list of microgrid sensors.

        !!! note
        This RPC endpoint streams metrics data for sensors of one or more microgrids.
        Clients need to provide at least one microgrid ID and one sensor ID
        to get a result.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def ReceiveAggregatedMicrogridSensorsDataStream(self, request, context):
        """Streams aggregated metrics based on user-defined formulas for a list of microgrid
        sensors.

        !!! note
        This RPC endpoint retrieves aggregated historical metrics data based on user-defined
        formulas for microgrid sensors. At least one formula for one microgrid must be provided
        for a valid result.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_ReportingServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'ReceiveMicrogridComponentsDataStream': grpc.unary_stream_rpc_method_handler(
                    servicer.ReceiveMicrogridComponentsDataStream,
                    request_deserializer=frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveMicrogridComponentsDataStreamRequest.FromString,
                    response_serializer=frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveMicrogridComponentsDataStreamResponse.SerializeToString,
            ),
            'ReceiveAggregatedMicrogridComponentsDataStream': grpc.unary_stream_rpc_method_handler(
                    servicer.ReceiveAggregatedMicrogridComponentsDataStream,
                    request_deserializer=frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveAggregatedMicrogridComponentsDataStreamRequest.FromString,
                    response_serializer=frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveAggregatedMicrogridComponentsDataStreamResponse.SerializeToString,
            ),
            'ReceiveMicrogridSensorsDataStream': grpc.unary_stream_rpc_method_handler(
                    servicer.ReceiveMicrogridSensorsDataStream,
                    request_deserializer=frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveMicrogridSensorsDataStreamRequest.FromString,
                    response_serializer=frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveMicrogridSensorsDataStreamResponse.SerializeToString,
            ),
            'ReceiveAggregatedMicrogridSensorsDataStream': grpc.unary_stream_rpc_method_handler(
                    servicer.ReceiveAggregatedMicrogridSensorsDataStream,
                    request_deserializer=frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveAggregatedMicrogridSensorsDataStreamRequest.FromString,
                    response_serializer=frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveAggregatedMicrogridSensorsDataStreamResponse.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'frequenz.api.reporting.v1.Reporting', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))
    server.add_registered_method_handlers('frequenz.api.reporting.v1.Reporting', rpc_method_handlers)


 # This class is part of an EXPERIMENTAL API.
class Reporting(object):
    """The Reporting service provides services for real-time and historical metrics monitoring
    of various microgrid components like Batteries, EV Chargers, and Inverters.

    Utilize these APIs for tasks ranging from real-time metric streaming to complex,
    formula-driven historical data aggregation. For detailed information on component
    categories and the metrics they provide, please consult the referenced component categories
    imported above.

    """

    @staticmethod
    def ReceiveMicrogridComponentsDataStream(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_stream(
            request,
            target,
            '/frequenz.api.reporting.v1.Reporting/ReceiveMicrogridComponentsDataStream',
            frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveMicrogridComponentsDataStreamRequest.SerializeToString,
            frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveMicrogridComponentsDataStreamResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def ReceiveAggregatedMicrogridComponentsDataStream(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_stream(
            request,
            target,
            '/frequenz.api.reporting.v1.Reporting/ReceiveAggregatedMicrogridComponentsDataStream',
            frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveAggregatedMicrogridComponentsDataStreamRequest.SerializeToString,
            frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveAggregatedMicrogridComponentsDataStreamResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def ReceiveMicrogridSensorsDataStream(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_stream(
            request,
            target,
            '/frequenz.api.reporting.v1.Reporting/ReceiveMicrogridSensorsDataStream',
            frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveMicrogridSensorsDataStreamRequest.SerializeToString,
            frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveMicrogridSensorsDataStreamResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def ReceiveAggregatedMicrogridSensorsDataStream(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_stream(
            request,
            target,
            '/frequenz.api.reporting.v1.Reporting/ReceiveAggregatedMicrogridSensorsDataStream',
            frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveAggregatedMicrogridSensorsDataStreamRequest.SerializeToString,
            frequenz_dot_api_dot_reporting_dot_v1_dot_reporting__pb2.ReceiveAggregatedMicrogridSensorsDataStreamResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)
